> For the complete documentation index, see [llms.txt](https://docs.essencefinance.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.essencefinance.io/development/smart-contracts/dao/timelock/essencedaotimelock.md).

# EssenceDAOTimelock

## EssenceDAOTimelock

### Functions

#### constructor

```solidity
function constructor(
    address core_,
    address admin_,
    uint256 delay_,
    uint256 minDelay_
) public
```

**Parameters**

| Name        | Type    | Description |
| ----------- | ------- | ----------- |
| `core_`     | address |             |
| `admin_`    | address |             |
| `delay_`    | uint256 |             |
| `minDelay_` | uint256 |             |

#### queueTransaction

```solidity
function queueTransaction(
    address target,
    uint256 value,
    string signature,
    bytes data,
    uint256 eta
) public returns (bytes32)
```

queue a transaction, with pausability

**Parameters**

| Name        | Type    | Description |
| ----------- | ------- | ----------- |
| `target`    | address |             |
| `value`     | uint256 |             |
| `signature` | string  |             |
| `data`      | bytes   |             |
| `eta`       | uint256 |             |

#### vetoTransactions

```solidity
function vetoTransactions(
    address[] targets,
    uint256[] values,
    string[] signatures,
    bytes[] datas,
    uint256[] etas
) public
```

veto a group of transactions

**Parameters**

| Name         | Type       | Description |
| ------------ | ---------- | ----------- |
| `targets`    | address\[] |             |
| `values`     | uint256\[] |             |
| `signatures` | string\[]  |             |
| `datas`      | bytes\[]   |             |
| `etas`       | uint256\[] |             |

#### executeTransaction

```solidity
function executeTransaction(
    address target,
    uint256 value,
    string signature,
    bytes data,
    uint256 eta
) public returns (bytes)
```

execute a transaction, with pausability

**Parameters**

| Name        | Type    | Description |
| ----------- | ------- | ----------- |
| `target`    | address |             |
| `value`     | uint256 |             |
| `signature` | string  |             |
| `data`      | bytes   |             |
| `eta`       | uint256 |             |

#### governorSetPendingAdmin

```solidity
function governorSetPendingAdmin(
    address newAdmin
) public
```

allow a governor to set a new pending timelock admin

**Parameters**

| Name       | Type    | Description |
| ---------- | ------- | ----------- |
| `newAdmin` | address |             |

#### rollback

```solidity
function rollback() external
```

one-time option to roll back the Timelock to old timelock

guardian-only, and expires after the deadline. This function is here as a fallback in case something goes wrong.

## IChiDAO

### Functions

#### updateTimelock

```solidity
function updateTimelock(
    address newTimelock
) external
```

**Parameters**

| Name          | Type    | Description |
| ------------- | ------- | ----------- |
| `newTimelock` | address |             |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.essencefinance.io/development/smart-contracts/dao/timelock/essencedaotimelock.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
